import java.applet.*;
import java.awt.*;

public class Film extends Applet implements Runnable {

	private AudioClip ac;
	private Thread film;		//(1)

	private Graphics graphics;	//(2)
	private Image images[];	//(3)
	private int currImage;	//(4)
	private int imgWidth;	//(5)
	private int imgHeight;	//(6)
	private boolean allLoaded;	//(7)

	private String bild = "image";	//(8)
	private String ext = "gif";	//(9)
	private int bps = 15;	//(10)
	private int von = 1;	//(11)
	private int bis = 20;	//(12)

	private final String FILM_PARAM = "film";	//(13)
	private final String EXT_PARAM = "ext";
	private final String BPS_PARAM = "bps";
	private final String VON_PARAM = "von";
	private final String BIS_PARAM = "bis";

	public String[][] getParameterInfo() {	//(14)
		String[][] info =
		{
			{ FILM_PARAM, "String",
						"Prfix der Bilddateien" },
			{ EXT_PARAM, "String",
						"Suffix (GIF oder JPG)" },
			{ BPS_PARAM, "int",
						"Bilder pro Sekunde" },
			{ VON_PARAM, "int", "Erstes Bild" },
			{ BIS_PARAM, "int", "Letztes Bild" },
		};
		return info;		
	}
	public void init() {		//(15)
		String param;
		param = getParameter(FILM_PARAM);
		if (param != null)
			bild = param;
		param = getParameter(EXT_PARAM);
		if (param != null)
			ext = param;
		param = getParameter(BPS_PARAM);
		if (param != null)
			bps = Integer.parseInt(param);
		param = getParameter(VON_PARAM);
		if (param != null)
			von = Integer.parseInt(param);
		param = getParameter(BIS_PARAM);
		if (param != null)
			bis = Integer.parseInt(param);
//		play(getCodeBase(),"sounds/geogoril.au");
	}
	private void displayImage(Graphics g) {	//(16)
		if (!allLoaded)	//(17)
			return;
		g.drawImage(images[currImage],	//(18)
		   (getSize().width - imgWidth)   / 2,
		   (getSize().height - imgHeight) / 2, null);
	}
	public void paint(Graphics g) {
		if (allLoaded) {		//(19)
			Rectangle r = g.getClipBounds();	//(20)
			g.clearRect(r.x, r.y,
						r.width, r.height);	//(21)
			displayImage(g);	//(22)
		}
		else
			g.drawString("Bilder werden geladen...",
								10, 20);	//(23)
	}
	public void start()	 {//(24)
		if (film == null) {
			film = new Thread(this);
			film.start();
		}
	}
	public void stop() {		//(25)
		ac.stop();
		if (film != null) {
			film = null;
		}
	}
	public void run() {		//(26)
		String musik = new String("sounds/"+"jamba.au");
		ac = getAudioClip(getCodeBase(),musik);
		ac.loop();

		currImage = 0;		//(27)
		if (!allLoaded) {	//(28)
	    		repaint();			//(29)
    			graphics = getGraphics();	//(30)
    			images = new Image[bis-von+1];	//(31)
	    		MediaTracker tracker =
					new MediaTracker(this);	//(32)
    			String image;	//(33)
    			for (int i = von; i <= bis; i++) {	//(34)
	    			image = bild + ((i < 10) ? "0" : "")
						+ i 	+ "." + ext;	//(35)
				images[i - von] =	
						getImage(getDocumentBase(),
								image);	//(36)
				tracker.addImage(images[i-von]
								,0);	//(37)
	    		}
			try {
				tracker.waitForAll();	//(38)
				allLoaded=!tracker.isErrorAny();	//(39)
			}
			catch (InterruptedException e) {
			}
			if (!allLoaded) {	//(40)
				stop();		//(41)
				graphics.drawString("Ladefehler",
								10, 40);	//(42)
				return;
			}
			imgWidth = images[0].getWidth(this);	//(43)
			imgHeight = images[0].getHeight(this);	//(44)
		}
		repaint();				//(45)
		while (film == Thread.currentThread()) {			//(46)
			try {
				displayImage(graphics);	//(47)
				currImage++;	//(48)
				if (currImage == bis - von +1)
					currImage = 0;	//(49)
				Thread.currentThread().sleep(1000/bps);	//(50)
			}
			catch (InterruptedException e) {
				stop();
			}
		}
	}
}
